Index: dll/win32/browseui/lang/bg-BG.rc
===================================================================
--- dll/win32/browseui/lang/bg-BG.rc	(revision 69455)
+++ dll/win32/browseui/lang/bg-BG.rc	(working copy)
@@ -264,7 +264,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Назад"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "Напред"
 END
 
Index: dll/win32/browseui/lang/de-DE.rc
===================================================================
--- dll/win32/browseui/lang/de-DE.rc	(revision 69455)
+++ dll/win32/browseui/lang/de-DE.rc	(working copy)
@@ -282,7 +282,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Zurück"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "Vorwärts"
 END
 
Index: dll/win32/browseui/lang/en-US.rc
===================================================================
--- dll/win32/browseui/lang/en-US.rc	(revision 69455)
+++ dll/win32/browseui/lang/en-US.rc	(working copy)
@@ -282,7 +282,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Back"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "Forward"
 END
 
Index: dll/win32/browseui/lang/es-ES.rc
===================================================================
--- dll/win32/browseui/lang/es-ES.rc	(revision 69455)
+++ dll/win32/browseui/lang/es-ES.rc	(working copy)
@@ -265,7 +265,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Atrás"
+    IDS_BACK "Volver a %s\0"
     IDS_FORWARD "Adelante"
 END
 
Index: dll/win32/browseui/lang/he-IL.rc
===================================================================
--- dll/win32/browseui/lang/he-IL.rc	(revision 69455)
+++ dll/win32/browseui/lang/he-IL.rc	(working copy)
@@ -266,7 +266,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Back"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "Forward"
 END
 
Index: dll/win32/browseui/lang/it-IT.rc
===================================================================
--- dll/win32/browseui/lang/it-IT.rc	(revision 69455)
+++ dll/win32/browseui/lang/it-IT.rc	(working copy)
@@ -264,7 +264,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Indietro"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "Avanti"
 END
 
Index: dll/win32/browseui/lang/pl-PL.rc
===================================================================
--- dll/win32/browseui/lang/pl-PL.rc	(revision 69455)
+++ dll/win32/browseui/lang/pl-PL.rc	(working copy)
@@ -272,7 +272,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Wstecz"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "Dalej"
 END
 
Index: dll/win32/browseui/lang/ro-RO.rc
===================================================================
--- dll/win32/browseui/lang/ro-RO.rc	(revision 69455)
+++ dll/win32/browseui/lang/ro-RO.rc	(working copy)
@@ -266,11 +266,11 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Înapoi"
+    IDS_BACK "Înapoi la %s\0"
     IDS_FORWARD "Înainte"
 END
 
Index: dll/win32/browseui/lang/ru-RU.rc
===================================================================
--- dll/win32/browseui/lang/ru-RU.rc	(revision 69455)
+++ dll/win32/browseui/lang/ru-RU.rc	(working copy)
@@ -266,7 +266,7 @@
 
 STRINGTABLE
 BEGIN
-  IDS_BACK "Назад"
+    IDS_BACK "Back to %s\0"
   IDS_FORWARD "Вперед"
 END
 
Index: dll/win32/browseui/lang/sq-AL.rc
===================================================================
--- dll/win32/browseui/lang/sq-AL.rc	(revision 69455)
+++ dll/win32/browseui/lang/sq-AL.rc	(working copy)
@@ -283,7 +283,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Mrapa"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "Perpara"
 END
 
Index: dll/win32/browseui/lang/tr-TR.rc
===================================================================
--- dll/win32/browseui/lang/tr-TR.rc	(revision 69455)
+++ dll/win32/browseui/lang/tr-TR.rc	(working copy)
@@ -264,7 +264,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Geri"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "İleri"
 END
 
Index: dll/win32/browseui/lang/uk-UA.rc
===================================================================
--- dll/win32/browseui/lang/uk-UA.rc	(revision 69455)
+++ dll/win32/browseui/lang/uk-UA.rc	(working copy)
@@ -266,7 +266,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "Назад"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "Вперед"
 END
 
Index: dll/win32/browseui/lang/zh-CN.rc
===================================================================
--- dll/win32/browseui/lang/zh-CN.rc	(revision 69455)
+++ dll/win32/browseui/lang/zh-CN.rc	(working copy)
@@ -284,7 +284,7 @@
 
 STRINGTABLE
 BEGIN
-    IDS_BACK "后退"
+    IDS_BACK "Back to %s\0"
     IDS_FORWARD "前进"
 END
 
Index: dll/win32/browseui/travellog.cpp
===================================================================
--- dll/win32/browseui/travellog.cpp	(revision 69455)
+++ dll/win32/browseui/travellog.cpp	(working copy)
@@ -428,6 +428,7 @@
     CTravelEntry                            *destinationEntry;
     wchar_t                                 tempString[MAX_PATH];
     wchar_t                                 templateString[200];
+    wchar_t                                 *resourceString;
     HRESULT                                 hResult;
 
     if (pwzText == NULL)
@@ -442,7 +443,11 @@
         return hResult;
     if (iOffset < 0)
     {
-        wcscpy(templateString, L"Back to %s");
+        hResult = LoadStringW(_AtlBaseModule.GetResourceInstance(),
+                            IDS_BACK, (wchar_t*)&resourceString, 0);
+        if (FAILED_UNEXPECTEDLY(hResult))
+            return hResult;
+        wcscpy(templateString, resourceString);
     }
     else
     {