Index: media/rapps/7zip.txt
===================================================================
--- media/rapps/7zip.txt	(revision 69855)
+++ media/rapps/7zip.txt	(working copy)
@@ -4,14 +4,14 @@
 
 [Section]
 Name = 7-Zip
-Version = 15.05b
+Version = 15.10
 License = LGPL
 Description = A file archiving utility with support for 7zip, zip, tar, rar and many other archive formats.
-Size = 1.14 MB
+Size = 1.20 MB
 Category = 12
 URLSite = http://www.7-zip.org/
-URLDownload = http://www.7-zip.org/a/7z1505.exe
-SHA1 = ece8bbd4c8903095d44e99196219c953a1d47bfd
+URLDownload = http://www.7-zip.org/a/7z1510.msi
+SHA1 = de3b42f5a01534294416a7ab6c40380a8fdf0c4d
 CDPath = none
 
 [Section.0407]
@@ -22,7 +22,7 @@
 
 [Section.040c]
 Description = Utilitaire pour créer et ouvrir les fichiers 7zip, zip, tar, rar et d'autres archives.
-Size = 1,14 Mo
+Size = 1,20 Mo
 
 [Section.0410]
 Description = Utilità per creare e aprire 7zip, zip, tar, rar e altri file archivio.
@@ -35,7 +35,7 @@
 
 [Section.0418]
 Description = Utilitar de arhivare a fișierelor, compatibil cu 7zip, zip, tar, rar și multe alte formate de arhive.
-Size = 1,14 Mo
+Size = 1,20 Mo
 
 [Section.0419]
 Description = Утилита для создания и открытия 7zip, zip, tar, rar и других архивных файлов.
@@ -42,7 +42,7 @@
 
 [Section.041f]
 Description = 7zip, zip, tar, rar ve başka birçok belgelik biçimi destekli bir kütük belgelikleme aracı.
-Size = 1,14 MB
+Size = 1,03 MB
 
 [Section.0422]
 Description = Утиліта для створення та відкриття 7zip, zip, tar, rar та інших архівних файлів.
Index: media/rapps/ccleaner.txt
===================================================================
--- media/rapps/ccleaner.txt	(revision 69855)
+++ media/rapps/ccleaner.txt	(working copy)
@@ -4,14 +4,14 @@
 
 [Section]
 Name = CCleaner
-Version = 5.08
+Version = 5.10
 License = Freeware
 Description = A decent tool for cleaning temporary files and general computer maintenance.
-Size = 6.25 MB
+Size = 6.35 MB
 Category = 12
 URLSite = http://www.piriform.com/ccleaner
-URLDownload = http://download.piriform.com/ccsetup508.exe
-SHA1 = aa7affcbdaf13c3872f32eaccf3befb92fd0fa80
+URLDownload = http://download.piriform.com/ccsetup510.exe
+SHA1 = 2cf9f87aa2ea689d9b9f5cced4c51b2595c19027
 CDPath = none
 
 [Section.0407]
@@ -24,12 +24,12 @@
 [Section.041f]
 License = Ücretsiz
 Description = PC'nizi temizleme için çok iyi araç.
-Size = 6,25 MB
+Size = 6,36 MB
 
 [Section.0418]
 License = Gratuită
 Description = Utilitar pentru mentenanța ordinii în configurația sistemului.
-Size = 6,25 Mo
+Size = 6,26 Mo
 
 [Section.0804]
 Description = 非常好的工具，清理您的电脑。
Index: media/rapps/gnucash.txt
===================================================================
--- media/rapps/gnucash.txt	(revision 69855)
+++ media/rapps/gnucash.txt	(working copy)
@@ -5,14 +5,14 @@
 
 [Section]
 Name = GnuCash
-Version = 2.6.7
+Version = 2.6.9
 License = GPL
 Description = A personal and small-business financial-accounting software, freely licensed under the GNU GPL and available for GNU/Linux, BSD, Solaris, Mac OS X and Microsoft Windows.
-Size = 92.8 MB
+Size = 95.8 MB
 Category = 10
 URLSite = http://gnucash.org/
-URLDownload = http://downloads.sourceforge.net/sourceforge/gnucash/gnucash%20%28stable%29/2.6.7/gnucash-2.6.7-setup.exe
-SHA1 = 7fcdd842de45b0724947e21c9dc674d77b7740f5
+URLDownload = http://downloads.sourceforge.net/sourceforge/gnucash/gnucash%20%28stable%29/2.6.9/gnucash-2.6.9-setup.exe
+SHA1 = 546d17a91ed96100407e675df55ea46484f9036b
 CDPath = none
 
 [Section.0407]
@@ -20,11 +20,11 @@
 
 [Section.0418]
 Description = Program de contabilitate financiară pentru uz personal și întreprinderi mici, oferit sub licența gratuită GNU GPL. Este disponibil pentru GNU/Linux, BSD, Solaris, Mac OS X și Windows.
-Size = 92,8 Mo
+Size = 95,8 Mo
 
 [Section.041f]
 Description = GNU GPL altında özgürce ruhsatlanmış, GNU/Linux, BSD, Solaris, Mac OS X ve Microsoft Windows için kullanılabilir, bir şahsî ve küçük iş mâlî muhâsebe yazılımı.
-Size = 92,8 MB
+Size = 95,8 MB
 
 [Section.0a]
 Description = Un programa de contabilidad personal y de PYMEs liberado bajo los términos de la GNU GPL. Está disponible para GNU/Linux, BSD, Solaris, Mac OS X y Microsoft Windows.
Index: media/rapps/nirlauncher.txt
===================================================================
--- media/rapps/nirlauncher.txt	(revision 69855)
+++ media/rapps/nirlauncher.txt	(working copy)
@@ -4,14 +4,14 @@
 
 [Section]
 Name = NirLauncher
-Version = 1.19.54
+Version = 1.19.56
 License = Freeware
 Description = A package of more than 180 utilities for Windows.
 Size = 21.05 MB
 Category = 12
 URLSite = http://launcher.nirsoft.net/
-URLDownload = http://download.nirsoft.net/nirsoft_package_1.19.54.zip
-SHA1 = 9adc1343c6d97a5bab08a20899e203eadf701987
+URLDownload = http://download.nirsoft.net/nirsoft_package_1.19.56.zip
+SHA1 = f682ff2ce2112092b8baeddab6c89838e9f4b290 
 CDPath = none
 
 [Section.0407]
Index: media/rapps/npp.txt
===================================================================
--- media/rapps/npp.txt	(revision 69855)
+++ media/rapps/npp.txt	(working copy)
@@ -4,14 +4,14 @@
 
 [Section]
 Name = Notepad++
-Version = 6.8.1
+Version = 6.8.6
 License = GPL
 Description = A full featured, free text editor with many plug-ins.
-Size = 5.4 MB
+Size = 3.9 MB
 Category = 6
 URLSite = http://notepad-plus-plus.org/
-URLDownload = https://notepad-plus-plus.org/repository/6.x/6.8.1/npp.6.8.1.Installer.exe
-SHA1 = d2ce3ab2d7dee81d065a4a700c8c233c252a22d2
+URLDownload = https://notepad-plus-plus.org/repository/6.x/6.8.6/npp.6.8.6.Installer.exe
+SHA1 = 2daca44b863dd37a204409bb1c1a7266a1746201
 CDPath = none
 
 [Section.0407]
@@ -22,7 +22,7 @@
 
 [Section.040c]
 Description = Un éditeur de texte.
-Size = 5,4 Mo
+Size = 3,9 Mo
 URLSite = http://notepad-plus-plus.org/fr/
 
 [Section.0410]
@@ -36,7 +36,7 @@
 
 [Section.0418]
 Description = Editor complet și gratuit de text, cu multe extensii.
-Size = 5,4 Mo
+Size = 3,9 Mo
 
 [Section.0419]
 Description = Текстовый редактор.
@@ -46,7 +46,7 @@
 
 [Section.041f]
 Description = Birçok eklentilerle, tüm husûsiyetli ücretsiz bir metin düzenleyicisi.
-Size = 5,4 MB
+Size = 3,9 MB
 
 [Section.0422]
 Description = Текстовый редактор.
Index: media/rapps/peazip.txt
===================================================================
--- media/rapps/peazip.txt	(revision 69855)
+++ media/rapps/peazip.txt	(working copy)
@@ -4,14 +4,14 @@
 
 [Section]
 Name = PeaZip
-Version = 5.7.0
+Version = 5.8.1
 License = LGPL v3, OpenCandy EULA
 Description = A free, cross-platform, open source file and archive manager. It supports over 150 archive formats.
-Size = 6.1 MB
+Size = 6.41 MB
 Category = 12
 URLSite = http://peazip.sourceforge.net/
-URLDownload = http://download.sourceforge.net/project/peazip/5.7.0/peazip-5.7.0.WINDOWS.exe
-SHA1 = 97cad78d1f9a998050e07553f3d4fa4379eecb93
+URLDownload = http://download.sourceforge.net/project/peazip/5.8.1/peazip-5.8.1.WINDOWS.exe
+SHA1 = 5e34de2e83307fb3674fb09d24276866aaa994c9
 CDPath = none
 
 [Section.0407]
@@ -28,12 +28,12 @@
 
 [Section.0418]
 Description = Gestionar de fișiere și arhivare gratuit, multiplatformă, cu surse deschise. Recunoaște peste 150 tipuri de arhive.
-Size = 6,1 Mo
+Size = 6,41 Mo
 
 [Section.041f]
 License = LGPL sürüm 3, OpenCandy EULA
 Description = Ücretsiz, çapraz platform, açık kaynak bir kütük ve belgelik yöneticisidir. 150'den çok belgelikleme biçimini destekler.
-Size = 6,1 MB
+Size = 6,41 MB
 
 [Section.0804]
 Description = 免费的、 跨平台的、 开放源代码文件和档案管理器。它支持超过 150 的档案格式。
Index: media/rapps/reshack.txt
===================================================================
--- media/rapps/reshack.txt	(revision 69855)
+++ media/rapps/reshack.txt	(working copy)
@@ -5,7 +5,7 @@
 
 [Section]
 Name = Resource Hacker
-Version = 4.2.4
+Version = 4.2.5
 License = Freeware
 Description = A freeware utility to view, modify, rename, add, delete and extract resources in 32bit & 64bit Windows executables and resource files (*.res).
 Size = 2.7 MB
Index: media/rapps/rosbe.txt
===================================================================
--- media/rapps/rosbe.txt	(revision 69855)
+++ media/rapps/rosbe.txt	(working copy)
@@ -1,16 +1,16 @@
-; UTF-8
+﻿; UTF-8
 ; Turkish translation by Erdem Ersoy (eersoy93) (erdemersoy@live.com)
 ; Simplified Chinese translation by Henry Tang Ih (henrytang5247) (henrytang2@hotmail.com)
 
 [Section]
 Name = ReactOS Build Environment
-Version = 2.1.1
+Version = 2.1.3
 License = GPL
 Description = Allows you to build the ReactOS Source. For more instructions see ReactOS wiki.
-Size = 28.3 MB
+Size = 32.2 MB
 Category = 7
 URLSite = http://reactos.org/wiki/Build_Environment
-URLDownload = http://download.sourceforge.net/reactos/RosBE-2.1.1.exe
-SHA1 = 3daec4a5df5adf5679eaba25c39b4779afea3b4f
+URLDownload = http://download.reactos.org/reactos/RosBE-Windows/i386/2.1.3/RosBE-2.1.3.exe
+SHA1 = 73cdd8b49af919064abced95872423e4be2afe6f
 CDPath = none
 
@@ -25,7 +25,7 @@
 
 [Section.040c]
 Description = Vous permet de compiler le code source de ReactOS. Pour plus d'instructions, reportez-vous au wiki ReactOS.
-Size = 28,3 Mo
+Size = 32,2 Mo
 
 [Section.0410]
 Description = Permette di compilare i sorgenti di ReactOS. Per maggiori informazioni consultare il Wiki di ReactOS.
@@ -38,12 +38,12 @@
 
 [Section.0418]
 Description = Permite compilarea surselor ReactOS. Pentru instrucțiuni, consultați wiki ReactOS.
-Size = 28,3 Mo
+Size = 32,2 Mo
 
 [Section.041f]
 Name = ReactOS Yapma Ortamı
 Description = ReactOS Kaynak Kodları'nı derlemenize olanak sağlar. Daha çok açıklama için ReactOS Wiki'ye bakınız.
-Size = 28,3 MB
+Size = 32,2 MB
 
 [Section.0422]
 Description = Дозволяє зібрати ReactOS з вихідних кодів. За детальною інформацією дивіться в ReactOS Вікі.