Index: dll/win32/syssetup/lang/bg-BG.rc
===================================================================
--- dll/win32/syssetup/lang/bg-BG.rc	(revision 69810)
+++ dll/win32/syssetup/lang/bg-BG.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Собственик"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/cs-CZ.rc
===================================================================
--- dll/win32/syssetup/lang/cs-CZ.rc	(revision 69810)
+++ dll/win32/syssetup/lang/cs-CZ.rc	(working copy)
@@ -161,6 +161,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Vlastník"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/de-DE.rc
===================================================================
--- dll/win32/syssetup/lang/de-DE.rc	(revision 69810)
+++ dll/win32/syssetup/lang/de-DE.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Besitzer"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/el-GR.rc
===================================================================
--- dll/win32/syssetup/lang/el-GR.rc	(revision 69810)
+++ dll/win32/syssetup/lang/el-GR.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Κάτοχος"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/en-US.rc
===================================================================
--- dll/win32/syssetup/lang/en-US.rc	(revision 69810)
+++ dll/win32/syssetup/lang/en-US.rc	(working copy)
@@ -174,6 +174,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Owner"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/es-ES.rc
===================================================================
--- dll/win32/syssetup/lang/es-ES.rc	(revision 69810)
+++ dll/win32/syssetup/lang/es-ES.rc	(working copy)
@@ -156,6 +156,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Propietario"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/et-EE.rc
===================================================================
--- dll/win32/syssetup/lang/et-EE.rc	(revision 69810)
+++ dll/win32/syssetup/lang/et-EE.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Owner"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/fr-FR.rc
===================================================================
--- dll/win32/syssetup/lang/fr-FR.rc	(revision 69810)
+++ dll/win32/syssetup/lang/fr-FR.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Propriétaire"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/he-IL.rc
===================================================================
--- dll/win32/syssetup/lang/he-IL.rc	(revision 69810)
+++ dll/win32/syssetup/lang/he-IL.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "בעלים"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/hu-HU.rc
===================================================================
--- dll/win32/syssetup/lang/hu-HU.rc	(revision 69810)
+++ dll/win32/syssetup/lang/hu-HU.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Tulajdonos"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/id-ID.rc
===================================================================
--- dll/win32/syssetup/lang/id-ID.rc	(revision 69810)
+++ dll/win32/syssetup/lang/id-ID.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Owner"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/it-IT.rc
===================================================================
--- dll/win32/syssetup/lang/it-IT.rc	(revision 69810)
+++ dll/win32/syssetup/lang/it-IT.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Proprietario"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/ja-JP.rc
===================================================================
--- dll/win32/syssetup/lang/ja-JP.rc	(revision 69810)
+++ dll/win32/syssetup/lang/ja-JP.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "所有者"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/nl-NL.rc
===================================================================
--- dll/win32/syssetup/lang/nl-NL.rc	(revision 69810)
+++ dll/win32/syssetup/lang/nl-NL.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Eigenaar"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/no-NO.rc
===================================================================
--- dll/win32/syssetup/lang/no-NO.rc	(revision 69810)
+++ dll/win32/syssetup/lang/no-NO.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Eier"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/pl-PL.rc
===================================================================
--- dll/win32/syssetup/lang/pl-PL.rc	(revision 69810)
+++ dll/win32/syssetup/lang/pl-PL.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Właściciel"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/pt-BR.rc
===================================================================
--- dll/win32/syssetup/lang/pt-BR.rc	(revision 69810)
+++ dll/win32/syssetup/lang/pt-BR.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Dono"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/ro-RO.rc
===================================================================
--- dll/win32/syssetup/lang/ro-RO.rc	(revision 69810)
+++ dll/win32/syssetup/lang/ro-RO.rc	(working copy)
@@ -164,6 +164,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Owner"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/ru-RU.rc
===================================================================
--- dll/win32/syssetup/lang/ru-RU.rc	(revision 69810)
+++ dll/win32/syssetup/lang/ru-RU.rc	(working copy)
@@ -157,6 +157,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Владелец"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/sk-SK.rc
===================================================================
--- dll/win32/syssetup/lang/sk-SK.rc	(revision 69810)
+++ dll/win32/syssetup/lang/sk-SK.rc	(working copy)
@@ -161,6 +161,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Vlastník"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/sq-AL.rc
===================================================================
--- dll/win32/syssetup/lang/sq-AL.rc	(revision 69810)
+++ dll/win32/syssetup/lang/sq-AL.rc	(working copy)
@@ -174,6 +174,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administratorër"
+    IDS_MACHINE_OWNER_NAME "Zotëruesi"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/tr-TR.rc
===================================================================
--- dll/win32/syssetup/lang/tr-TR.rc	(revision 69810)
+++ dll/win32/syssetup/lang/tr-TR.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Yönetici"
+    IDS_MACHINE_OWNER_NAME "Sahip"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/uk-UA.rc
===================================================================
--- dll/win32/syssetup/lang/uk-UA.rc	(revision 69810)
+++ dll/win32/syssetup/lang/uk-UA.rc	(working copy)
@@ -163,6 +163,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "Власник"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/lang/zh-CN.rc
===================================================================
--- dll/win32/syssetup/lang/zh-CN.rc	(revision 69810)
+++ dll/win32/syssetup/lang/zh-CN.rc	(working copy)
@@ -155,6 +155,7 @@
      *   Also check the IDD_COMPUTERPAGE dialog.
      */
     IDS_ADMINISTRATOR_NAME "Administrator"
+    IDS_MACHINE_OWNER_NAME "所有者"
 END
 
 STRINGTABLE
Index: dll/win32/syssetup/resource.h
===================================================================
--- dll/win32/syssetup/resource.h	(revision 69810)
+++ dll/win32/syssetup/resource.h	(working copy)
@@ -102,6 +102,7 @@
 #define IDS_TIMEOUT                3307
 #define IDS_REASON_UNKNOWN         3308
 #define IDS_ADMINISTRATOR_NAME     3309
+#define IDS_MACHINE_OWNER_NAME     3310
 
 #define IDS_WZD_NAME            3450
 #define IDS_WZD_SETCOMPUTERNAME 3451
@@ -113,4 +114,4 @@
 
 #define IDS_STATUS_INSTALL_DEV 3500
 
-#define IDR_GPL 4000
+#define IDR_GPL 4000
\ No newline at end of file
Index: dll/win32/syssetup/wizard.c
===================================================================
--- dll/win32/syssetup/wizard.c	(revision 69810)
+++ dll/win32/syssetup/wizard.c	(working copy)
@@ -5,6 +5,7 @@
  * PURPOSE:         GUI controls
  * PROGRAMMERS:     Eric Kohl
  *                  Pierre Schweitzer <heis_spiter@hotmail.com>
+ *                  Ismael Ferreras Morezuelas <swyterzone+ros@gmail.com>
  */
 
 /* INCLUDES *****************************************************************/
@@ -454,11 +455,20 @@
     {
         case WM_INITDIALOG:
         {
+            /* set a localized ('Owner') placeholder string as default */
+            if (LoadStringW(hDllInstance, IDS_MACHINE_OWNER_NAME, OwnerName, _countof(OwnerName)))
+            {
+                SendDlgItemMessage(hwndDlg, IDC_OWNERNAME, WM_SETTEXT, 0, (LPARAM)OwnerName);
+            }
+
             SendDlgItemMessage(hwndDlg, IDC_OWNERNAME, EM_LIMITTEXT, 50, 0);
             SendDlgItemMessage(hwndDlg, IDC_OWNERORGANIZATION, EM_LIMITTEXT, 50, 0);
 
             /* Set focus to owner name */
             SetFocus(GetDlgItem(hwndDlg, IDC_OWNERNAME));
+
+            /* Select the default text to quickly overwrite it by typing */
+            SendDlgItemMessage(hwndDlg, IDC_OWNERNAME, EM_SETSEL, 0, -1);
         }
         break;
 