Index: libreoffice.txt
===================================================================
--- libreoffice.txt	(revision 70198)
+++ libreoffice.txt	(working copy)
@@ -1,17 +1,17 @@
-; UTF-8
+﻿; UTF-8
 ; Turkish translation by Erdem Ersoy (eersoy93) (erdemersoy@live.com)
 ; Simplified Chinese translation by Henry Tang Ih (henrytang5247) (henrytang2@hotmail.com)
 
 [Section]
 Name = LibreOffice
-Version = 4.4.5
+Version = 5.1.1.1
 License = LGPL
 Description = A powerful and open source office suite. It has been forked from OpenOffice.
-Size = 213.93 MB
+Size = 211 MB
 Category = 6
-URLSite = http://www.documentfoundation.org/
-URLDownload = http://download.documentfoundation.org/libreoffice/stable/4.4.5/win/x86/LibreOffice_4.4.5_Win_x86.msi
-SHA1 = 2d8bcd51cc2ab3ff5e321b25ff86fe1b04df8315
+URLSite = https://libreoffice.org
+URLDownload = https://downloadarchive.documentfoundation.org/libreoffice/old/5.1.1.1/win/x86/LibreOffice_5.1.1.1_Win_x86.msi
+SHA1 = ec18dfc048635df4cf358cce09cd6f4f7b02a6a1
 CDPath = none
 
 [Section.0407]
@@ -22,7 +22,7 @@
 
 [Section.040c]
 Description = Précédemment appelé OpenOffice. Suite bureautique open source.
-Size = 213,93 Mo
+Size = 211 Mo
 
 [Section.0410]
 Description = Precedentemente chiamato OpenOffice. Open Source Office Suite.
@@ -35,11 +35,11 @@
 
 [Section.0418]
 Description = O suită completă de aplicații de birotică, cu surse deschise. Reprezintă o bifurcare a dezvoltării OpenOffice.
-Size = 213,93 Mo
+Size = 211 Mo
 
 [Section.041f]
 Description = Güçlü ve açık kaynak bir ofis paketi. OpenOffice'ten çatallanılmıştır.
-Size = 213,93 MB
+Size = 211 MB
 
 [Section.0422]
 Description = Відкритий офісний пакет.
Index: libreofficehelp.txt
===================================================================
--- libreofficehelp.txt	(revision 70198)
+++ libreofficehelp.txt	(working copy)
@@ -1,25 +1,25 @@
-; UTF-8
+﻿; UTF-8
 ; Turkish translation by Erdem Ersoy (eersoy93) (erdemersoy@live.com)
 ; Simplified Chinese translation by Henry Tang Ih (henrytang5247) (henrytang2@hotmail.com)
 
 [Section]
 Name = LibreOffice Help Pack
-Version = 4.4.5
+Version = 4.4.6
 License = GPLv3
 Description = Offline help content of LibreOffice.
 Size = 5.12 MB
 Category = 6
 URLSite = http://www.documentfoundation.org/
-URLDownload = http://download.documentfoundation.org/libreoffice/stable/4.4.5/win/x86/LibreOffice_4.4.5_Win_x86_helppack_en-US.msi
-SHA1 = 3543c7e9e0db3c3dd8bcf64c24139fdb6610e8d0
+URLDownload = https://downloadarchive.documentfoundation.org/libreoffice/old/5.1.1.1/win/x86/LibreOffice_5.1.1.1_Win_x86_helppack_en-US.msi
+SHA1 = bedc74f6940ac7e6012fb859dcc4d57f09c3d24e
 CDPath = none
 
 [Section.0407]
 Name = LibreOffice Help Pack
 Description = Offline Hilfe für LibreOffice.
-Size = 7.10 MB
-URLDownload = http://download.documentfoundation.org/libreoffice/stable/4.4.5/win/x86/LibreOffice_4.4.5_Win_x86_helppack_de.msi
-SHA1 = d6ec18c31a359e8abd2811e9eb16e9be0b18797b
+Size = 7.24 MB
+URLDownload = https://downloadarchive.documentfoundation.org/libreoffice/old/5.1.1.1/win/x86/LibreOffice_5.1.1.1_Win_x86_helppack_de.msi
+SHA1 = 7104a3c241d913f960847ed4297f5f73c019a345
 
 [Section.0418]
 Description = Conținut de asistență și ajutor (în limba engleză) pentru LibreOffice.
@@ -28,21 +28,21 @@
 [Section.0a]
 Name = LibreOffice — Paquete de ayuda
 Description = Páginas de ayuda para LibreOffice.
-Size = 7.00 MB
-URLDownload = http://download.documentfoundation.org/libreoffice/stable/4.4.5/win/x86/LibreOffice_4.4.5_Win_x86_helppack_es.msi
-SHA1 = 64f96e8ddcb0126eb19db6c9dc24d6a51c509b3a
+Size = 7.16 MB
+URLDownload = https://downloadarchive.documentfoundation.org/libreoffice/old/5.1.1.1/win/x86/LibreOffice_5.1.1.1_Win_x86_helppack_es.msi
+SHA1 = 19dcd3f1ba6243c4a002c7d0811c53a6a4ec792a
 
 [Section.041f]
 Name = LibreOffice Yardım Paketi
 License = GPL sürüm 3
 Description = LibreOffice'in çevrim dışı yardım içeriği.
-Size = 6,85 MB
-URLDownload = http://download.documentfoundation.org/libreoffice/stable/4.4.5/win/x86/LibreOffice_4.4.5_Win_x86_helppack_tr.msi
-SHA1 = 4de936b3ceb6f90850494fe16a942affbb1cc114
+Size = 6,92 MB
+URLDownload = https://downloadarchive.documentfoundation.org/libreoffice/old/5.1.1.1/win/x86/LibreOffice_5.1.1.1_Win_x86_helppack_tr.msi
+SHA1 = 30895a76babbdd223c411f849710701a22edee69
 
 [Section.0804]
 Name = LibreOffice 帮助包
 Description = LibreOffice 的脱机帮助内容。
 Size = 9.50 MB
-URLDownload = http://download.documentfoundation.org/libreoffice/stable/4.4.5/win/x86/LibreOffice_4.4.5_Win_x86_helppack_zh-CN.msi
-SHA1 = 8ff9fd6be59d0a8be133406c3666ed1d747d16f6
+URLDownload = https://downloadarchive.documentfoundation.org/libreoffice/old/5.1.1.1/win/x86/LibreOffice_5.1.1.1_Win_x86_helppack_zh-CN.msi
+SHA1 = 8fb0900f53172d8b6d497ade71d2e5215f569396